@echo off
:: Manage Windows 10 Default Power Plans
:: Author: Hendrik Vermaak, 27 January 2018

:: Start Command Prompt Maximised
if not "%1" == "max" start /MAX cmd /c %0 max & exit/b

:: Set window title
title Manage Windows 10 Default Power Plans

color 02

:: Check for administrative permissions 
>nul 2>&1 "%SYSTEMROOT%\system32\cacls.exe" "%SYSTEMROOT%\system32\config\system" 
:: If error flag set, we do not have admin. 
if '%errorlevel%' NEQ '0' ( 
echo Requesting administrative privileges... 
goto UACPrompt 
) else ( goto gotAdmin ) 
:UACPrompt 
echo Set UAC = CreateObject^("Shell.Application"^) > "%temp%\getadmin.vbs" 
echo UAC.ShellExecute "cmd.exe", "/C """"%~f0""""", , "runas", 1 >> "%temp%\getadmin.vbs" 
cscript "%temp%\getadmin.vbs" 
exit /B 
:gotAdmin 
if exist "%temp%\getadmin.vbs" ( del "%temp%\getadmin.vbs" ) 
pushd "%CD%"
CD /D "%~dp0" 
:: BatchGotAdmin (Run as Admin code ends)

:mainmenu
:: Main Script Start
for /F "eol= delims=~" %%d in ('CD') do set curpath=%%d
pushd "%curpath%"

:: Windows Default GUID's
SET BP=381b4222-f694-41f0-9685-ff5bb260df2e
SET HP=8c5e7fda-e8bf-4a96-9a85-a6e23a8c635c
SET PS=a1841308-3541-4fab-bc81-f71556f20b4a
SET UP=e9a42b02-d5df-448d-aa00-03f14749eb61

:: Set User Active Power Plan GUID
for /f "tokens=*" %%i in ('Powercfg /getactivescheme ^| findstr /r /v "^$"') do set active=%%i
echo %active% > "%temp%\ActivePowerPlan.txt"
FOR /f "tokens=4 delims= " %%a IN (%temp%\ActivePowerPlan.txt) do ( set userguid=%%a )
if exist "%temp%\ActivePowerPlan.txt" ( del "%temp%\ActivePowerPlan.txt" )

:: Check if reboot is required to apply power plan changes.
reg query HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\Currentversion\RunOnce /v PendingRestart >nul 2>&1
if "%ErrorLevel%"=="0" ( goto pending ) else ( goto noreboot )

:pending
set "RR=Please restart the computer to apply the registry changes."

:noreboot
reg query HKEY_LOCAL_MACHINE\SOFTWARE\Policies\Microsoft\Power\PowerSettings /v ActivePowerScheme >nul 2>&1
if "%ErrorLevel%"=="0" ( set "PP=Power plan settings are managed by the system administrator" ) ELSE ( set "PP=All users are allowed to select and customize power plan settings" )
for /f "tokens=*" %%i in ('Powercfg /getactivescheme ^| findstr /r /v "^$"') do set ACTIVE=%%i
set ap=%ACTIVE:~19,36%
cls
echo =========================================================================================
echo                           Manage Windows 10 Default Power Plans
echo =========================================================================================
echo  Active %ACTIVE% *
echo =========================================================================================
echo  * %PP%. 
echo =========================================================================================
echo. %RR%
echo =========================================================================================
echo.
timeout /t 1 /nobreak >nul 2>&1
echo Please Select one of the options* below then press Enter:
echo.
echo.
echo [1]* Display list of power plans.
echo.
echo [2]* Export or Import Windows default power plans.
echo.
echo [3]* Select a power plan to set as active.
echo.
echo [4]* Allow or prevent all users to select and customize power plans.
echo.
echo [5]* Reset and restore all power plans to default settings.
echo.
echo. 
echo.
echo [0]* Exit.
echo.
SET /p main1="Select: "
IF %main1%==1 (
    goto menu1
) else IF %main1%==2 (
    goto menu2
) else IF %main1%==3 (
    goto menu3
) else IF %main1%==4 (
    goto menu4
) else IF %main1%==5 (
    goto menu5
) else IF %main1%==0 (
    goto exit
) else ( echo Incorrect Selection 
timeout /t 1 /nobreak >nul 2>&1
goto mainmenu
)

:menu1
cls
echo.
echo =========================================================================================
echo                                    List of Power Plans 
echo =========================================================================================
timeout /t 1 /nobreak >nul 2>&1
powercfg /list
echo.
echo.
choice /C:YN /M "Save the list to the current directory of this script?"
if errorlevel 2 goto mainmenu
if errorlevel 1 goto savelist

:savelist
powercfg.exe /list > "%curpath%\Power Plans List.txt"
echo.
timeout /t 1 /nobreak >nul 2>&1
cls
echo.
echo * Power Plans List saved to the current directory of this script.
echo.
echo.
echo.
echo Please press any key to go back to the main menu...
pause >nul
goto mainmenu

:menu2
cls
echo =========================================================================================
echo                        Export or Import Windows default Power Plans
echo =========================================================================================
echo.
timeout /t 1 /nobreak >nul 2>&1
echo Please Select one of the options* below then press Enter:
echo.
echo.
echo [1]* Export default power plans to the current directory of this script.
echo.
echo [2]* Import default power plans from the current directory of this script.
echo.
echo [3]* Go back to the main menu.
echo.
echo.
echo.
echo [0]* Exit.
echo.
SET /p main1="Select: "
IF %main1%==1 (
    goto export
) else IF %main1%==2 (
    goto import
) else IF %main1%==3 (
    goto mainmenu 
) else IF %main1%==0 (
    goto exit
) else ( echo Incorrect Selection 
timeout /t 1 /nobreak >nul 2>&1
goto menu2
)
echo.

:export
cls
echo.
echo =========================================================================================
echo 				     Export default power plans
echo ========================================================================================= 
echo.
choice /C:YN /M "Export the default power plans now?  PLEASE NOTE PREVIOUS EXPORTED POWER PLANS WILL BE OVERWRITTEN!"
if errorlevel 2 goto mainmenu
if errorlevel 1 goto export1

:export1
powercfg.exe /list > "%curpath%\Exported_Power_Plans_List.txt"
powercfg.exe /export "%curpath%\Balanced.pow" %BP% 
powercfg.exe /export "%curpath%\High Performance.pow" %HP%
powercfg.exe /export "%curpath%\Power Saver.pow" %PS%
powercfg.exe /export "%curpath%\Ultimate Performance.pow" %UP%

echo.
echo.
timeout /t 1 /nobreak >nul 2>&1
cls
echo.
echo * Power plans exported to the current directory of this script.
echo.
echo.
echo.
echo Please press any key to go back to the main menu...
pause >nul
goto mainmenu

:import
cls
echo.
if exist "%curpath%\Balanced.pow" ( 
goto importexist ) else ( 
echo No power plan files found to import...
timeout /t 3 /nobreak >nul 2>&1
goto menu2 )

:importexist
echo.
choice /C:YN /M "Re/Import the default power plans now?  PLEASE NOTE CURRENT DEFAULT POWER PLANS WILL BE REPLACED!"
if errorlevel 2 goto mainmenu
if errorlevel 1 goto import1

:import1
echo.

:: Import Power Plans
powercfg.exe /setactive %BP%
powercfg.exe /delete %HP% >nul 2>&1
powercfg.exe /import "%curpath%\High Performance.pow" %HP%
powercfg.exe /setactive %HP%
powercfg.exe /delete %UP% >nul 2>&1
powercfg.exe /delete %BP% >nul 2>&1
powercfg.exe /delete %PS% >nul 2>&1
powercfg.exe /import "%curpath%\Balanced.pow" %BP%
powercfg.exe /import "%curpath%\Power Saver.pow" %PS%
powercfg.exe /import "%curpath%\Ultimate Performance.pow" %UP%
powercfg.exe /setactive %userguid%

cls
echo.
echo * Power plans imported.
timeout /t 1 /nobreak >nul 2>&1
powercfg /list
echo.
echo.
echo.
echo Please press any key to go back to the main menu...
pause >nul
goto mainmenu

:menu3
cls
echo =========================================================================================
echo                           Select a power plan to set as active
echo =========================================================================================
echo Current Active %active% *
echo =========================================================================================
echo.
timeout /t 1 /nobreak >nul 2>&1
echo Please Select one of the options* below then press Enter:
echo.
echo.
echo [1]* Set Balanced power plan as active.
echo.
echo [2]* Set High Performance power plan as active.
echo.
echo [3]* Set Power Saver power plan as active.
echo.
echo [4]* Set Ultimate Performance power plan as active.
echo.
echo.
echo.
echo [5]* Go back to the main menu.
echo.
echo [0]* Exit.
echo.
SET /p main1="Select: "
IF %main1%==1 (
    goto planbalanced
) else IF %main1%==2 (
    goto planhigh
) else IF %main1%==3 (
    goto planpowersaver
) else IF %main1%==4 (
    goto planultimate
) else IF %main1%==5 (
    goto mainmenu
) else IF %main1%==0 (
    goto exit
) else ( echo Incorrect Selection 
timeout /t 1 /nobreak >nul 2>&1
goto menu3
)
echo.

:planbalanced
cls
echo.
echo * Balanced power plan set as active.
powercfg.exe /setactive %BP%
echo.
timeout /t 1 /nobreak >nul 2>&1
powercfg /list
echo.
echo.
echo.
echo Please press any key to go back to the main menu...
pause >nul
goto mainmenu

:planhigh
cls
echo.
echo * High Performance power plan set as active.
powercfg.exe /setactive %HP%
echo.
timeout /t 1 /nobreak >nul 2>&1
powercfg /list
echo.
echo.
echo.
echo Please press any key to go back to the main menu...
pause >nul
goto mainmenu

:planpowersaver
cls
echo.
echo * Power Saver power plan set as active.
powercfg.exe /setactive %PS%
echo.
timeout /t 1 /nobreak >nul 2>&1
powercfg /list
echo.
echo.
echo.
echo Please press any key to go back to the main menu...
pause >nul
goto mainmenu

:planultimate
reg query "HKEY_LOCAL_MACHINE\SYSTEM\ControlSet001\Control\Power\User\PowerSchemes\e9a42b02-d5df-448d-aa00-03f14749eb61" >nul
if %ERRORLEVEL% EQU 0 goto setultimate
powercfg -duplicatescheme e9a42b02-d5df-448d-aa00-03f14749eb61
:setultimate
cls
echo.
echo * Ultimate Performance power plan set as active.
powercfg.exe /setactive %UP%
echo.
timeout /t 1 /nobreak >nul 2>&1
powercfg /list
echo.
echo.
echo.
echo Please press any key to go back to the main menu...
pause >nul
goto mainmenu


:menu4
cls
echo.
echo =================================================================================
echo           Allow or prevent all users to select and customize power plans
echo =================================================================================
reg query HKEY_LOCAL_MACHINE\SOFTWARE\Policies\Microsoft\Power\PowerSettings /v ActivePowerScheme >nul 2>&1
if "%ErrorLevel%"=="0" ( echo  * Power plan settings are managed by the system administrator. ) else ( echo  * All users are allowed select and customize power plans. )
echo =================================================================================
echo.
timeout /t 1 /nobreak >nul 2>&1
echo Please Select one of the options* below then press Enter:
echo.
echo.
echo [1]* Prevent all users to select and customize power plans.
echo.
echo [2]* Allow all users to select and customize power plans.
echo.
echo [3]* Go back to the main menu.
echo.
echo.
echo.
echo [0]* Exit.
echo.
SET /p main1="Select: "
IF %main1%==1 (
    goto lock
) else IF %main1%==2 (
    goto unlock
) else IF %main1%==3 (
    goto mainmenu
) else IF %main1%==0 (
    goto exit
) else ( echo Incorrect Selection 
timeout /t 1 /nobreak >nul 2>&1
goto menu4
)

:lock
cls
echo.
echo =========================================================================================
echo 		       Prevent all users to select and customize power plans
echo =========================================================================================
echo.
reg query HKEY_LOCAL_MACHINE\SOFTWARE\Policies\Microsoft\Power\PowerSettings /v ActivePowerScheme >nul 2>&1
if "%ErrorLevel%"=="0" ( goto locked1 ) else ( goto notlocked2 )
:locked1
cls
echo.
echo * All users are already not allowed to select and customize power plans.
timeout /t 4 /nobreak >nul 2>&1
goto menu4

:notlocked2
reg add "HKEY_LOCAL_MACHINE\SOFTWARE\Policies\Microsoft\Power\PowerSettings" /v ActivePowerScheme /t REG_SZ /d %ap% /f
reg add HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\Currentversion\RunOnce /v PendingRestart /t REG_SZ /d "Power Plan Script System Restart Required"
timeout /t 2 /nobreak >nul 2>&1

:lock1
cls
echo.
echo * The current active power plan is now specified as the default power plan for all users.
echo.
echo * The computer needs to be Restarted for the Setting to take effect.
timeout /t 2 /nobreak >nul 2>&1
echo.
echo.
echo [1]* Restart the computer now? Please ensure any unfinished work is saved before restarting.
echo.
echo [2]* Go back to the main menu.
echo.
echo.
echo.
echo [0]* Exit the script without Restarting.
echo.
SET /p main1="Select: "
IF %main1%==1 (
    goto restart
) else IF %main1%==2 (
    goto mainmenu
) else IF %main1%==0 (
    goto exit
) else ( echo Incorrect Selection 
timeout /t 1 /nobreak >nul 2>&1
goto lock1
)

:unlock
cls
echo.
echo =========================================================================================
echo 			Allow all users to select and customize power plans
echo =========================================================================================
echo.
reg query HKEY_LOCAL_MACHINE\SOFTWARE\Policies\Microsoft\Power\PowerSettings /v ActivePowerScheme >nul 2>&1
if "%ErrorLevel%"=="1" ( goto locked2 ) else ( goto unlocked3 )
:locked2
cls
echo.
echo * All users are already allowed to select and customize power plans.
timeout /t 4 /nobreak >nul 2>&1
goto menu4

:unlocked3
reg delete "HKEY_LOCAL_MACHINE\SOFTWARE\Policies\Microsoft\Power\PowerSettings" /f
reg add HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\Currentversion\RunOnce /v PendingRestart /t REG_SZ /d "Power Plan Script System Restart Required"
timeout /t 2 /nobreak >nul 2>&1

:unlock1
cls
echo.
echo =========================================================================================
echo 			Allow all users to select and customize power plans
echo =========================================================================================
echo.
echo * All users are now allowed to select and customize power plans.
echo.
echo * The computer needs to be restarted for the setting to take effect.
timeout /t 2 /nobreak >nul 2>&1
echo.
echo.
echo [1]* Restart the computer now? Please ensure any unfinished work is saved before restarting.
echo.
echo [2]* Go back to the main menu.
echo.
echo.
echo.
echo [0]* Exit the script without Restarting.
echo.
SET /p main1="Select: "
IF %main1%==1 (
    goto restart
) else IF %main1%==2 (
    goto mainmenu
) else IF %main1%==0 (
    goto exit
) else ( echo Incorrect Selection 
timeout /t 1 /nobreak >nul 2>&1
goto unlock1
)

:menu5
cls
echo.
echo =========================================================================================
echo       	       Reset and restore all power plans to default settings
echo =========================================================================================
timeout /t 1 /nobreak >nul 2>&1
echo.
echo [1]* Reset and restore all power plans to default settings now? PLEASE NOTE THAT CUSTOM POWER PLANS WILL ALSO BE REMOVED!.
echo.
echo [2]* Go back to the main menu.
echo.
echo.
echo.
echo [0]* Exit.
echo.
SET /p main1="Select: "
IF %main1%==1 (
    goto querylocked
) else IF %main1%==2 (
    goto mainmenu
) else IF %main1%==0 (
    goto exit
) else ( echo Incorrect Selection 
timeout /t 1 /nobreak >nul 2>&1
goto menu5
)

:querylocked
reg query HKEY_LOCAL_MACHINE\SOFTWARE\Policies\Microsoft\Power\PowerSettings /v ActivePowerScheme >nul 2>&1
if "%ErrorLevel%"=="0" ( goto restore1 ) else ( goto restore2 )
:locked1

:restore1
echo.
reg delete "HKEY_LOCAL_MACHINE\SOFTWARE\Policies\Microsoft\Power\PowerSettings" /f
reg add HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\Currentversion\RunOnce /v PendingRestart /t REG_SZ /d "Power Plan Script System Restart Required"
powercfg -restoredefaultschemes
powercfg.exe /setactive %userguid%

cls
echo.
echo =========================================================================================
echo       	       Reset and restore all power plans to default settings
echo =========================================================================================
echo.
echo * Power plans have been reset and restored to default settings.
echo.
timeout /t 2 /nobreak >nul 2>&1
echo The computer needs to be Restarted for the Setting to take effect.
echo.
echo [1]* Restart the computer now? Please ensure any unfinished work is saved before restarting.
echo.
echo [2]* Go back to the main menu.
echo.
echo.
echo.
echo [0]* Exit the script without Restarting.
echo.
SET /p main1="Select: "
IF %main1%==1 (
    goto restart
) else IF %main1%==2 (
    goto mainmenu
) else IF %main1%==0 (
    goto exit
) else ( echo Incorrect Selection 
timeout /t 1 /nobreak >nul 2>&1
goto restore1
)

:restore2
powercfg -restoredefaultschemes
cls
echo.
echo =========================================================================================
echo       	       Reset and restore all power plans to default settings
echo =========================================================================================
echo.
echo * Power plans have been reset and restored to default settings.
echo.
powercfg /list
echo.
timeout /t 2 /nobreak >nul 2>&1
echo.
echo [1]* Go back to the main menu.
echo.
echo.
echo.
echo [0]* Exit.
echo.
SET /p main1="Select: "
IF %main1%==1 (
    goto mainmenu
) else IF %main1%==0 (
    goto exit
) else ( echo Incorrect Selection 
timeout /t 1 /nobreak >nul 2>&1
goto restore2
)

:restart
reg delete HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\Currentversion\RunOnce /v PendingRestart /f >nul 2>&1
timeout /t 1 /nobreak >nul 2>&1
start c:/windows/system32/shutdown /r /t 30
goto :eof

:exit
set sec=5
:continue
cls
echo.
echo. %RR%
echo.
echo The command prompt window will automatically close in %sec% Seconds...
set /a sec="%sec%-1"
if %sec%==-1  goto done
timeout /t 1 >nul
goto continue
:done
exit
